// Karma configuration
// http://karma-runner.github.io/0.10/config/configuration-file.html
'use strict';

module.exports = function(config) {
  config.set({
    // base path, that will be used to resolve files and exclude
    basePath: '',

    // testing framework to use (jasmine/mocha/qunit/...)
    //frameworks: ['jasmine'],
    //frameworks: ['jasmine','requirejs','ng-scenario'],
    frameworks: ['jasmine','requirejs'],

    // list of files / patterns to load in the browser
    files: [
      'app/bower_components/requirejs/require.js',
      'app/bower_components/jquery/jquery.min.js',
      'app/bower_components/jqueryui/ui/jquery-ui.js',
      'app/bower_components/jquery-simulate/jquery.simulate.js',
      'app/bower_components/underscore/underscore-min.js',
      //'app/bower_components/domready/ready.js',

      'app/bower_components/angular/angular.js',
      'app/bower_components/angular-mocks/angular-mocks.js',
      'app/bower_components/angular-resource/angular-resource.js',
      'app/bower_components/angular-cookies/angular-cookies.js',
      'app/bower_components/angular-sanitize/angular-sanitize.js',
      'app/bower_components/angular-route/angular-route.js',

      'test/test-main.js',

      {pattern: 'test/**/*.js', included: false},
      {pattern: 'app/scripts/**/*.js', included: false},
      {pattern: 'test/spec/{,*/}*.js', included: false}
    ],

    // list of files / patterns to exclude
    //exclude: [],
    exclude: ['app/angular/main.js'],

    // web server port
    port: 8080,
    //port: 9101,

    // level of logging
    // possible values: LOG_DISABLE || LOG_ERROR || LOG_WARN || LOG_INFO || LOG_DEBUG
    logLevel: config.LOG_INFO,
    //logLevel: config.LOG_DEBUG,

    // enable / disable watching file and executing tests whenever any file changes
    //autoWatch: true,

    // Start these browsers, currently available:
    // - Chrome
    // - ChromeCanary
    // - Firefox
    // - Opera
    // - Safari (only Mac)
    // - PhantomJS
    // - IE (only Windows)
    // Chris - apparently some UI tests only work with Chrome

//    browsers: ['Chrome'],
    browsers: ['PhantomJS'],
    //browsers: ['Firefox'],

    // Continuous Integration mode
    // if true, it capture browsers, run tests and exit
    singleRun: false,
    autoWatch: true
  });

};
